"use strict";
this.name               = "combat_MFD";
this.author               = "Norby, Zireael";
this.copyright            = "2014 Norby, Zireael";
this.description         = "Makes MFDs more useful by displaying some info";
this.version            = "1.3";
this.licence     = "CC BY-NC-SA 4.0";

this.$ExactNumbers = false; //energy and shield values for debug
this.$DmgEqs = []; //store damaged eq keys

this.startUp = function() {
	if(player.ship && player.ship.isValid)
		this.$PlayerPrevPos = player.ship.position;
	else this.$PlayerPrevPos = [0,0,0];
	this.$Target = null;
	this.$TargetPrevPos = [0,0,0];
	this.$Hws = worldScripts.hardships;
	this.$Iws = worldScripts["IronHide Armour Script"];
	this.$Ows = worldScripts.towbar;
	this.$Sws = worldScripts.shieldequalizercapacitors;
	this.$Tws = worldScripts.telescope;
	this.$DmgEqs = []; //store damaged eq keys
}
	
this.equipmentDamaged = function(equipment) {
	this.$DmgEqs.push(equipment);
//	log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
}

this.shipBeingAttacked = this.shipBeingAttackedUnsuccessfully = function(whom) {
     if(whom && whom.script) whom.script.$combat_MFD_attacked = true; //flag for display Laser type
}

this.shipWillLaunchFromStation = function() {
	if(this.$Sws) {
		this.$Sws.togglemessages = "OFF";
		this.$Sws.togglesoundfx2 = "OFF";
	}
	if(player.ship.equipmentStatus("EQ_COMBATMFD") == "EQUIPMENT_OK")
		this.$InfoTimer = new Timer(this, this.$showCombatInfo.bind(this), 1, 0.5);
	//log("CombatMFD",player.ship.equipmentStatus("EQ_COMBATMFD")+" "+this.$InfoTimer);//debug
	this.$InfoTimer2Done = false;

	delete this.$DmgEqs; //store damaged eq keys
	this.$DmgEqs = [];
	var eq = player.ship.equipment;
	var i=-1;
	while(eq[++i]) { //skip noname eqs awarded by NumericHUD
		if( eq[i].name.length > 0
			&& player.ship.equipmentStatus(eq[i].equipmentKey)=="EQUIPMENT_DAMAGED")
			this.$DmgEqs.push(eq[i].equipmentKey);
	}
	if( this.$ExactNumbers ) {//debug
		var s = system.addShips("pirate", 1,
			system.mainStation.position.add(player.ship.heading.multiply(3000)), 100);//debug target
		if( s && s[0]) {
			//s[0].forwardWeapon = null;//setAI("nullAI.plist");
			s[0].bounty = 1;
			s[0].target = player.ship;
			//s[0].displayName = s[0].name + " Target";
		}
	}
}

this.$showCombatInfo = function() {
	var p = player.ship;
	if(p && p.isValid) {
		var target = "";
		var pp = p.position;
		var sp = Math.round(p.speed/10)*10; //stable but can not shown Q-Charger nor FTL drive
		if(sp > 0.9 * p.maxSpeed )
			sp = Math.round(0.2*pp.distanceTo(this.$PlayerPrevPos))*10;//not stable, must round to 10
		if( sp > 10000000 ) sp = Math.round( sp / 1000000 ) + " Mm/s";
		else if( sp > 1000000 ) sp = Math.round( sp / 1000 ) + " km/s";
		else sp += " m/s";
		this.$PlayerPrevPos = pp;
		var t = p.target;
		if(t && t.isValid) {
			var tdn = t.displayName;//must before telescopemarker
			var st = "";
			if(t.isWormhole) {
				tdn = "Wormhole";
				if(p.equipmentStatus("EQ_WORMHOLE_SCANNER") == "EQUIPMENT_OK") {
					if( this.$InfoTimer2Done && this.$LastWormhole == t ) {
						//log("CombatMFD",t.expiryTime+" "+clock.seconds+" "+t.arrivalTime);//debug
						if(t.destination) tdn += " to "+System.systemNameForID(t.destination);
						if(t.expiryTime) tdn = this.$AlignedText(tdn, " Expire in "+
							Math.round( t.expiryTime - clock.seconds )+" s");
						if(t.arrivalTime) st = "\nTravel Time: "+(Math.round(
							(t.arrivalTime - clock.seconds)/360)/10)+" h";
					} else { //5s delay before show Wormhole info
						tdn += " scanning...";
						if(this.$LastWormhole != t) {
							this.$LastWormhole = t;
							this.$InfoTimer2Done = false;
							if(this.$InfoTimer2) {
								this.$InfoTimer2.stop();
								delete this.$InfoTimer2;
							}
							this.$InfoTimer2 = new Timer(this, this.$showWormholeInfo.bind(this), 7);
						}
					}
				}
			}
			var tsp = "";
			var t2 = null;
			if(this.$Tws && t.dataKey=="telescopemarker") {
				t2 = this.$Tws.$TelescopeList[this.$Tws.$TelescopeListi-1]; //this.$Tws.$TelescopeTarget;
				if(t2 && t2.isValid) t = t2;
				var k = tdn.indexOf("km ");
				if( k > -1 && k < 10 ) tdn = tdn.substr( k+3 ); //chop the x km from the begin of marker name
			}
			if(t.maxSpeed > 0) {
				if(this.$Target == t) { //need 2 pos. for speed
					tsp = Math.round(t.speed/10)*10; //stable but can not shown Q-Charger nor FTL drive
					if(tsp > 0.9 * t.maxSpeed )
						tsp = Math.round(0.2*t.position.distanceTo(this.$TargetPrevPos))*10;
				} else {
					this.$Target = t; //first time save position
					tsp = Math.round(t.speed/10)*10;
				}
				if( tsp > 10000000 ) tsp = Math.round( tsp / 1000000 ) + " Mm/s";
				else if( tsp > 1000000 ) tsp = Math.round( tsp / 1000 ) + " km/s";
				else tsp = Math.round( tsp ) + " m/s";
				//tsp = "Speed: " + tsp;
			}
			if(!t2 && p.equipmentStatus("EQ_SCANNER_SHOW_MISSILE_TARGET") == "EQUIPMENT_OK"
				&& (!t.isWormhole&&t.isShip&&t.isPiloted||t.isDerelict)) {
				st = "Status:";
				if(t.isDerelict) {
					if(this.$Ows && t.script) { //Towbar status
						if(t.script.$TowbarUsableShip) st += " Usable!";
						else if(t.script.$TowbarMinedShip) st += " Mined";
						if(t.script.$TowbarEmptyShip) st += " Empty";
						else st += " Trap or Treasure";
					}
				} else if(t.bounty>50) st += " Fugitive";
				else if(t.bounty>0) st += " Offender";
				else st += " Clean";
				if( this.$ExactNumbers ) st = this.$AlignedText(st, Math.round(t.energy));//for debug
				else if(t.isDerelict) {
					st = this.$AlignedText(st, "Derelict");
				} else {
					if(t.energy && t.maxEnergy ) {
						if(t.energy < 0.2*t.maxEnergy ) st = this.$AlignedText(st, "Weak");
						else if(t.energy < 0.4*t.maxEnergy ) st = this.$AlignedText(st, "Damaged");
					}
				}
			}
			var r = Math.round(t.collisionRadius);
			var d = Math.round(t.position.distanceTo(pp)-r);
			if(d > 1000000000) d = Math.floor(d/1000000000)+" Mkm";
			else if(d > 25600) d = Math.floor(d/1000)+" km";
			else d += " m";
			if( r > 100000 ) r = Math.round( r / 1000 ) + " km";
			else r += " m";
			var sr = "Shield Radius";
			var laser = "";
			if( !t.isShip || t.isPlanet || t.isSun || t.isRock ) sr = "Radius";
			if( t.forwardWeapon ) laser = "Laser: Unknown";
			if( t.script && t.script.$combat_MFD_attacked && t.currentWeapon )
				laser = this.$AlignedText("Laser: "+t.currentWeapon.name,
							  "Range: "+Math.round(t.weaponRange/100)/10+" km");
			target = "\n\n"+tdn+
				"\n"+this.$AlignedText("Distance: "+d, tsp)+
				"\n"+sr+": "+r+
				"\n"+laser+
				"\n"+st;
			this.$TargetPrevPos = t.position;
		} else this.$Target = null;
		var fs = Math.round(p.forwardShield);
		if(this.$Sws) fs += Math.round(this.$Sws.secforwardshieldcapacitor);
		var as = Math.round(p.aftShield);
		if(this.$Sws) as += Math.round(this.$Sws.secaftshieldcapacitor);
		var eb = Math.floor(p.maxEnergy/64);//how many energy banks shown in hud
		var e = Math.ceil(p.energy/(p.maxEnergy/eb));
		var en;
		if( e < 2 ) en ="LAST BANK!";
		else { //add armour and shields as banks
			e = p.energy + Math.min(p.forwardShield, p.aftShield);
			if(this.$Sws) e += Math.min(this.$Sws.secforwardshieldcapacitor,
				this.$Sws.secaftshieldcapacitor);
			if(this.$Hws) e += Math.min(this.$Hws.$HardShips_Armour[0][0], //fw
				Math.min(this.$Hws.$HardShips_Armour[0][1],//aft
				Math.min(this.$Hws.$HardShips_Armour[0][2],//port
				Math.min(this.$Hws.$HardShips_Armour[0][3],//sb
				Math.min(this.$Hws.$HardShips_Armour[0][4],//top
					this.$Hws.$HardShips_Armour[0][5])))));//bottom
			if( this.$Iws ) {
				var ihs = missionVariables.ironHide_strength;
				e += ihs * ( missionVariables.ironHide_percentage / 100 ); ///
			}
			en = Math.round( e / 64 ) + " Banks";
		}
		var sh = this.$ForwardPercent(fs) + "%/" + this.$AftPercent(as) + "%"
		if( this.$ExactNumbers ) { //for debug
			en += ": "+Math.round(p.energy);
			sh += " ("+fs+"/"+as+")";
		}
		var dm = "";
		var dmg = "";
		var dmgeqs = [];
//		log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
		for( var i=0; i<this.$DmgEqs.length; i++ ) //remove fixed ones from the damaged list
			if(p.equipmentStatus(this.$DmgEqs[i])=="EQUIPMENT_DAMAGED")
				dmgeqs.push(this.$DmgEqs[i]);
		this.$DmgEqs = dmgeqs;
//		log("combat_MFD", "DmgEqs: "+this.$DmgEqs); //debug
		if( dmgeqs && dmgeqs.length > 0 ) {  //show the name of the lastly damaged equipment
			dmg = EquipmentInfo.infoForKey(dmgeqs[dmgeqs.length-1]).name;
			if( dmgeqs.length > 1 ) dm = "(+"+(dmgeqs.length-1)+")";//+how many other eq damaged
		}
		if(dmg.length > 0) dmg = this.$AlignedText("Damaged: "+dmg, dm);
		p.setMultiFunctionText("useful_MFD_combat_info",
			this.$AlignedText("Energy: "+Math.round(100*p.energy/p.maxEnergy)+"%", en)+
			"\nShields: "+sh+
			"\n"+this.$AlignedText("Fuel: "+(p.fuel).toFixed(1)+" ly", sp)+
			"\n"+dmg+target, false);
	}
}

this.$ForwardPercent = function(current) {
  var max = 128;//player.ship.maxForwardShield;
  var result = Math.round(100*current / max);
  return result;
}

this.$AftPercent = function(current) {
  var max = 128;//player.ship.maxAftShield;
  var result = Math.round(100*current / max);
  return result;
}

this.$showWormholeInfo = function() { //5s delay before show Wormhole info
	this.$InfoTimer2Done = true;
	if(this.$InfoTimer2) {
		this.$InfoTimer2.stop();
		delete this.$InfoTimer2;
	}
}

this.$AlignedText = function(left, right) { //insert as many spaces between as fill the line
	var space = " ";
	left += space;
	var t = left + right;
	while( global.defaultFont.measureString(t) < 14 ) {
		left += space;
		t = left + right;
	}
	return(t);
}